;  Copyright (C) 2006 Red Hat Inc.
;
;  This file is part of GAS, the GNU Assembler.
;
;  GAS is free software; you can redistribute it and/or modify
;  it under the terms of the GNU General Public License as published by
;  the Free Software Foundation; either version 2, or (at your option)
;  any later version.
;
;  GAS is distributed in the hope that it will be useful,
;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;  GNU General Public License for more details.
;
;  You should have received a copy of the GNU General Public License
;  along with GAS; see the file COPYING.  If not, write to
;  the Free Software Foundation, 59 Temple Place - Suite 330,
;  Boston, MA 02111-1307, USA.  */

macro	sdsp8	{-128;-1;0;1;127;0x7f}
macro	udsp8	{0;1;255;0xff}
macro	sdsp16	{-32768;-1;0;1;32767;0x7fff;sym}
macro	udsp16	{0;1;65535;0xffff;sym}
macro	abs16	{0;1;65535;0xffff;sym}
macro	udsp24	{0;1;16777215;0xffffff;sym}
macro	abs24	{0;1;16777215;0xffffff;sym}

macro	iaddrs	{{;{udsp8};{udsp16};{udsp24}}[a{0;1}];{{udsp8};{udsp16}}[sb];{{sdsp8};{sdsp16}}[fb]}
macro	addrs	{{iaddrs};{abs16};{abs24}}

macro	sdl	{r2r0;r3r1;a0;a1;{addrs}}

macro	isdl	{{sdl};[{iaddrs}]}

macro	g	{;:g}

	div.l	{sdl}
	divu.l	{sdl}
	divx.l	{sdl}

	mul.l	{sdl},r2r0
	mulu.l	{sdl},r2r0

	shanc.l	#{-16;-1;0;1;16},{isdl}
	shlnc.l	#{-16;-1;0;1;16},{isdl}
